/* Tabela GRUPOFISCAL: Item do Lanamento de Estoque */
/* Descrio: A trigger insere registros na tabela LOGOPERA a partir de alteraes na tabela GRUPOFISCAL */
/* Objetivo: Gerar um log que vai registrar as alteraes na tabela GRUPOFISCAL utilizando a tabela Geral de Logs de Operaes */

CREATE OR REPLACE TRIGGER LOG_GER_PARAMINTEGRA
AFTER DELETE OR INSERT OR UPDATE
ON PARAMINTEGRA FOR EACH ROW
DECLARE
  V_USUARIO      VARCHAR2(40);
  V_TIPO         VARCHAR2(1);
  V_ITPESQ       VARCHAR2(40);
  V_DESC         VARCHAR2(300);
  V_DTOPER       DATE;
  V_DSREMOTEADDR VARCHAR2(15);
  V_DSREMOTEHOST VARCHAR2(15);
  V_DSSERVERRDM  VARCHAR2(20);
  V_DSSERVMETHOD VARCHAR2(30);
  V_DSREMOTEOPER VARCHAR2(12);
BEGIN
   V_TIPO := '0';
   V_DESC := '';

   IF DELETING THEN
      IF :OLD.CDPARAMINT IS NOT NULL THEN
         V_DESC := V_DESC || 'Cod=' || :OLD.CDPARAMINT;
      END IF;

      IF :OLD.CDPRODGENE IS NOT NULL THEN
         V_DESC := V_DESC || ' ProdGeral=' || :OLD.CDPRODGENE;
      END IF;

      IF :OLD.CDPRODPSER IS NOT NULL THEN
         V_DESC := V_DESC || ' ProdPServ=' || :OLD.CDPRODPSER;
      END IF;

      IF :OLD.CDPRODDESP IS NOT NULL THEN
         V_DESC := V_DESC || ' ProdDesp=' || :OLD.CDPRODDESP;
      END IF;

      IF :OLD.CDPRODREFE IS NOT NULL THEN
         V_DESC := V_DESC || ' ProdRefei=' || :OLD.CDPRODREFE;
      END IF;

      IF :OLD.CDTPINDICE IS NOT NULL THEN
         V_DESC := V_DESC || ' TpIndice=' || :OLD.CDTPINDICE;
      END IF;

      IF :OLD.IDPERVALOR IS NOT NULL THEN
         V_DESC := V_DESC || ' PerValor=' || :OLD.IDPERVALOR;
      END IF;

      IF :OLD.CDINDICE IS NOT NULL THEN
         V_DESC := V_DESC || ' Indice=' || :OLD.CDINDICE;
      END IF;

      IF :OLD.CDFILIALPDV IS NOT NULL THEN
         V_DESC := V_DESC || ' FilialPDV=' || :OLD.CDFILIALPDV;
      END IF;

      IF :OLD.CDEMPRESAPDV IS NOT NULL THEN
         V_DESC := V_DESC || ' EmpresaPDV=' || :OLD.CDEMPRESAPDV;
      END IF;

      IF :OLD.CDCLIENTEPDV IS NOT NULL THEN
         V_DESC := V_DESC || ' ClientePDV=' || :OLD.CDCLIENTEPDV;
      END IF;

      IF :OLD.IDENTSAIOPDV IS NOT NULL THEN
         V_DESC := V_DESC || ' EntrSaiPDV=' || :OLD.IDENTSAIOPDV;
      END IF;

      IF :OLD.CDTPOPERPDV IS NOT NULL THEN
         V_DESC := V_DESC || ' TpOperPDV=' || :OLD.CDTPOPERPDV;
      END IF;

      IF :OLD.CDPRODPADDOS IS NOT NULL THEN
         V_DESC := V_DESC || ' ProdPadDOS=' || :OLD.CDPRODPADDOS;
      END IF;

      IF :OLD.IDENTRSAIDOP IS NOT NULL THEN
         V_DESC := V_DESC || ' EntrSaid=' || :OLD.IDENTRSAIDOP;
      END IF;

      IF :OLD.CDTIPOOPER IS NOT NULL THEN
         V_DESC := V_DESC || ' TipoOper=' || :OLD.CDTIPOOPER;
      END IF;

      IF :OLD.IDPERPRNVINC IS NOT NULL THEN
         V_DESC := V_DESC || ' PerPrNivel=' || :OLD.IDPERPRNVINC;
      END IF;

      IF :OLD.DSDIRIMPARQDIS IS NOT NULL THEN
         V_DESC := V_DESC || ' DiretorioDis=' || :OLD.DSDIRIMPARQDIS;
      END IF;

      V_TIPO         := '3';
      V_ITPESQ       := :OLD.CDPARAMINT;
   ELSE
      IF UPDATING THEN
         IF NVL(:NEW.CDPARAMINT,'!')   <> NVL(:OLD.CDPARAMINT,'!')  OR
            NVL(:NEW.CDPRODGENE,'!')   <> NVL(:OLD.CDPRODGENE,'!')  OR
            NVL(:NEW.CDPRODPSER ,'!')  <> NVL(:OLD.CDPRODPSER ,'!') OR
            NVL(:NEW.CDPRODDESP ,'!')  <> NVL(:OLD.CDPRODDESP ,'!') OR
            NVL(:NEW.CDPRODREFE ,'!')  <> NVL(:OLD.CDPRODREFE ,'!') OR
            NVL(:NEW.CDTPINDICE ,'!')  <> NVL(:OLD.CDTPINDICE ,'!') OR
            NVL(:NEW.IDPERVALOR ,'!')  <> NVL(:OLD.IDPERVALOR ,'!') OR
            NVL(:NEW.CDINDICE ,'!')    <> NVL(:OLD.CDINDICE ,'!')   OR
            NVL(:NEW.CDFILIALPDV ,'!') <> NVL(:OLD.CDFILIALPDV ,'!')OR
            NVL(:NEW.CDEMPRESAPDV ,'!')<> NVL(:OLD.CDEMPRESAPDV ,'!') OR
            NVL(:NEW.CDCLIENTEPDV,'!') <> NVL(:OLD.CDCLIENTEPDV,'!')OR
            NVL(:NEW.IDENTSAIOPDV,'!') <> NVL(:OLD.IDENTSAIOPDV,'!')OR
            NVL(:NEW.CDTPOPERPDV,'!')  <> NVL(:OLD.CDTPOPERPDV,'!') OR
            NVL(:NEW.CDPRODPADDOS,'!') <> NVL(:OLD.CDPRODPADDOS,'!')OR
            NVL(:NEW.IDENTRSAIDOP,'!') <> NVL(:OLD.IDENTRSAIDOP,'!')OR
            NVL(:NEW.CDTIPOOPER,'!')   <> NVL(:OLD.CDTIPOOPER,'!')  OR
            NVL(:NEW.IDPERPRNVINC,'!') <> NVL(:OLD.IDPERPRNVINC,'!') OR
            NVL(:NEW.DSDIRIMPARQDIS,'!') <> NVL(:OLD.DSDIRIMPARQDIS,'!') THEN

            IF NVL(:NEW.CDPARAMINT,'!') <> NVL(:OLD.CDPARAMINT,'!') THEN
               V_DESC := V_DESC || 'Cod=' || :NEW.CDPARAMINT;
            END IF;

            IF NVL(:NEW.CDPRODGENE,'!') <> NVL(:OLD.CDPRODGENE,'!') THEN
               V_DESC := V_DESC || ' ProdGeral=' || :NEW.CDPRODGENE;
            END IF;

            IF NVL(:NEW.CDPRODPSER ,'!') <> NVL(:OLD.CDPRODPSER ,'!') THEN
               V_DESC := V_DESC || ' ProdPServ=' || :NEW.CDPRODPSER;
            END IF;

            IF NVL(:NEW.CDPRODDESP ,'!') <> NVL(:OLD.CDPRODDESP ,'!') THEN
               V_DESC := V_DESC || ' ProdDesp=' || :NEW.CDPRODDESP;
            END IF;

            IF NVL(:NEW.CDPRODREFE ,'!') <> NVL(:OLD.CDPRODREFE ,'!') THEN
               V_DESC := V_DESC || ' ProdRefei=' || :NEW.CDPRODREFE;
            END IF;

            IF NVL(:NEW.CDTPINDICE ,'!') <> NVL(:OLD.CDTPINDICE ,'!') THEN
               V_DESC := V_DESC || ' TpIndice=' || :NEW.CDTPINDICE;
            END IF;

            IF NVL(:NEW.IDPERVALOR ,'!') <> NVL(:OLD.IDPERVALOR ,'!') THEN
               V_DESC := V_DESC || ' PerValor=' || :NEW.IDPERVALOR;
            END IF;

            IF NVL(:NEW.CDINDICE ,'!') <> NVL(:OLD.CDINDICE ,'!') THEN
               V_DESC := V_DESC || ' Indice=' || :NEW.CDINDICE;
            END IF;

            IF NVL(:NEW.CDFILIALPDV ,'!') <> NVL(:OLD.CDFILIALPDV ,'!') THEN
               V_DESC := V_DESC || ' FilialPDV=' || :NEW.CDFILIALPDV;
            END IF;

            IF NVL(:NEW.CDEMPRESAPDV ,'!') <> NVL(:OLD.CDEMPRESAPDV ,'!') THEN
               V_DESC := V_DESC || ' EmpresaSAPDV=' || :NEW.CDEMPRESAPDV;
            END IF;

            IF NVL(:NEW.CDCLIENTEPDV,'!') <> NVL(:OLD.CDCLIENTEPDV,'!') THEN
               V_DESC := V_DESC || ' ClientePDV=' || :NEW.CDCLIENTEPDV;
            END IF;

            IF NVL(:NEW.IDENTSAIOPDV,'!') <> NVL(:OLD.IDENTSAIOPDV,'!') THEN
               V_DESC := V_DESC || ' EntrSaiPDV=' || :NEW.IDENTSAIOPDV;
            END IF;

            IF NVL(:NEW.CDTPOPERPDV,'!') <> NVL(:OLD.CDTPOPERPDV,'!') THEN
               V_DESC := V_DESC || ' TpOperPDV=' || :NEW.CDTPOPERPDV;
            END IF;

            IF NVL(:NEW.CDPRODPADDOS,'!') <> NVL(:OLD.CDPRODPADDOS,'!') THEN
               V_DESC := V_DESC || ' ProdPadDOS=' || :NEW.CDPRODPADDOS;
            END IF;

            IF NVL(:NEW.IDENTRSAIDOP,'!') <> NVL(:OLD.IDENTRSAIDOP,'!') THEN
               V_DESC := V_DESC || ' EntrSaid=' || :NEW.IDENTRSAIDOP;
            END IF;

            IF NVL(:NEW.CDTIPOOPER,'!') <> NVL(:OLD.CDTIPOOPER,'!') THEN
               V_DESC := V_DESC || ' TipoOper=' || :NEW.CDTIPOOPER;
            END IF;

            IF NVL(:NEW.IDPERPRNVINC,'!') <> NVL(:OLD.IDPERPRNVINC,'!') THEN
               V_DESC := V_DESC || ' PerPrNivel=' || :NEW.IDPERPRNVINC;
            END IF;

            IF NVL(:NEW.DSDIRIMPARQDIS,'!') <> NVL(:OLD.DSDIRIMPARQDIS,'!') THEN
               V_DESC := V_DESC || ' PerPrNivel=' || :NEW.DSDIRIMPARQDIS;
            END IF;

            V_TIPO         := '2';
            V_ITPESQ       := :OLD.CDPARAMINT;
         END IF;
      ELSE
         IF :NEW.CDPARAMINT IS NOT NULL THEN
            V_DESC := V_DESC || 'Cod=' || :NEW.CDPARAMINT;
         END IF;

         IF :NEW.CDPRODGENE IS NOT NULL THEN
            V_DESC := V_DESC || ' ProdGeral=' || :NEW.CDPRODGENE;
         END IF;

         IF :NEW.CDPRODPSER IS NOT NULL THEN
            V_DESC := V_DESC || ' ProdPServ=' || :NEW.CDPRODPSER;
         END IF;

         IF :NEW.CDPRODDESP IS NOT NULL THEN
            V_DESC := V_DESC || ' ProdDesp=' || :NEW.CDPRODDESP;
         END IF;

         IF :NEW.CDPRODREFE IS NOT NULL THEN
            V_DESC := V_DESC || ' ProdRefei=' || :NEW.CDPRODREFE;
         END IF;

         IF :NEW.CDTPINDICE IS NOT NULL THEN
            V_DESC := V_DESC || ' TpIndice=' || :NEW.CDTPINDICE;
         END IF;

         IF :NEW.IDPERVALOR IS NOT NULL THEN
            V_DESC := V_DESC || ' PerValor=' || :NEW.IDPERVALOR;
         END IF;

         IF :NEW.CDINDICE IS NOT NULL THEN
            V_DESC := V_DESC || ' Indice=' || :NEW.CDINDICE;
         END IF;

         IF :NEW.CDFILIALPDV IS NOT NULL THEN
            V_DESC := V_DESC || ' FilialPDV=' || :NEW.CDFILIALPDV;
         END IF;

         IF :NEW.CDEMPRESAPDV IS NOT NULL THEN
            V_DESC := V_DESC || ' EmpresaPDV=' || :NEW.CDEMPRESAPDV;
         END IF;

         IF :NEW.CDCLIENTEPDV IS NOT NULL THEN
            V_DESC := V_DESC || ' ClientePDV=' || :NEW.CDCLIENTEPDV;
         END IF;

         IF :NEW.IDENTSAIOPDV IS NOT NULL THEN
            V_DESC := V_DESC || ' EntrSaiPDV=' || :NEW.IDENTSAIOPDV;
         END IF;

         IF :NEW.CDTPOPERPDV IS NOT NULL THEN
            V_DESC := V_DESC || ' TpOperPDV=' || :NEW.CDTPOPERPDV;
         END IF;

         IF :NEW.CDPRODPADDOS IS NOT NULL THEN
            V_DESC := V_DESC || ' ProdPadDOS=' || :NEW.CDPRODPADDOS;
         END IF;

         IF :NEW.IDENTRSAIDOP IS NOT NULL THEN
            V_DESC := V_DESC || ' EntrSaid=' || :NEW.IDENTRSAIDOP;
         END IF;

         IF :NEW.CDTIPOOPER IS NOT NULL THEN
            V_DESC := V_DESC || ' TipoOper=' || :NEW.CDTIPOOPER;
         END IF;

         IF :NEW.IDPERPRNVINC IS NOT NULL THEN
            V_DESC := V_DESC || ' DiretorioDis=' || :NEW.IDPERPRNVINC;
         END IF;

         V_TIPO         := '1';
         V_ITPESQ       := :NEW.CDPARAMINT;
      END IF;
   END IF;

   IF V_TIPO <> '0' THEN
      NMUSUARIO(V_USUARIO);
      WEBTUNNING(V_DSREMOTEADDR,
                 V_DSREMOTEHOST,
                 V_DSSERVERRDM,
                 V_DSSERVMETHOD,
                 V_DSREMOTEOPER);

      IF NOT V_DESC IS NULL THEN
         IF NOT V_USUARIO IS NULL THEN
            V_DTOPER := SYSDATE;

            INSERT INTO LOGOPERA
               (NMTABELA,   DTOPERACAO, NMRESPOPER,
                IDTIPOOPER, CDPESQITEM, DSOPERACAO,
                DSRDMUSUOPER, DSENDUSUOPER, DSNMUSUOPER, DSMETUSUOPER, CDORESPOPER)
            VALUES
               ('PARAMINTEGRA',  V_DTOPER, V_USUARIO,
                V_TIPO,      V_ITPESQ, V_DESC,
                V_DSSERVERRDM, V_DSREMOTEADDR, V_DSREMOTEHOST, V_DSSERVMETHOD, V_DSREMOTEOPER);
         END IF;
      END IF;
   END IF;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('LOG_GER_PARAMINTEGRA','4.09.060'); END;
/

