/* Sistemas Integrados TECNISA

Nome: 9548_QPRTRGO_LOG_QPR_ITEMINSAUDIT.SQL

Descrio:
   Trigger para gravar o log das alteraes

Criao:
   04/01/2018 - Jurandir Junio
*/

/* Tabela INSPECAUDIT.*/
/* Descrio: A trigger insere registros na tabela LOGOPERA a partir das alteraes na tabela
              ITEMINSAUDIT, para verifio de erros */
CREATE OR REPLACE TRIGGER LOG_QPR_ITEMINSAUDIT
AFTER DELETE OR INSERT OR UPDATE
ON ITEMINSAUDIT FOR EACH ROW
DECLARE
  V_DSREMOTEADDR VARCHAR2(15);
  V_DSREMOTEHOST VARCHAR2(15);
  V_DSSERVERRDM  VARCHAR2(20);
  V_DSSERVMETHOD VARCHAR2(30);
  V_DSREMOTEOPER VARCHAR2(12);
  V_GRAV_DESC    VARCHAR2(300);
  V_DESC         VARCHAR2(2000);
  V_LENGTH       FLOAT(10);
  V_CONT_LENGTH FLOAT(10);
  V_ITPESQ       VARCHAR2(80);
  V_NMOPERADOR   VARCHAR2(40);
  V_NRINCREST    VARCHAR2(40);
  V_IDTIPOOPER   VARCHAR2(1);
  V_CDFILLOGOPER VARCHAR2(4);

BEGIN
/* IDTIPOOPER - '1' - Incluso, '2' - Alterao, '3' - Excluso*/

   V_GRAV_DESC    := '';
   V_LENGTH       := '';  
   V_CONT_LENGTH  := 1;
   V_DESC       := '';
   V_ITPESQ     := '';
   V_NMOPERADOR := '';
   V_NRINCREST  := '';
   V_IDTIPOOPER := '';
   V_CDFILLOGOPER := '';
   
   NMUSUARIO(V_NMOPERADOR);
   WEBTUNNING(V_DSREMOTEADDR,
              V_DSREMOTEHOST,
              V_DSSERVERRDM,
              V_DSSERVMETHOD,
              V_DSREMOTEOPER);

   IF INSERTING THEN 

         IF :NEW.CDFILIAL IS NOT NULL THEN
            V_DESC := V_DESC || 'Filial= ' || NVL(:NEW.CDFILIAL,'') || ' ' ;
         END IF;

         IF :NEW.NRAUDITORIA IS NOT NULL THEN
            V_DESC := V_DESC || 'NrAudit.= ' || NVL(:NEW.NRAUDITORIA,'') || ' ' ;
         END IF;

         IF :NEW.NRINSPECAUDI IS NOT NULL THEN
            V_DESC := V_DESC || 'NrInspecAudit= ' || NVL(:NEW.NRINSPECAUDI,'') || ' ';
         END IF;

         IF :NEW.CDINSPECAO IS NOT NULL THEN
            V_DESC := V_DESC || 'CdInspecao= ' || NVL(:NEW.CDINSPECAO,'') || ' ';
         END IF;

         IF :NEW.CDRESPINSPEC IS NOT NULL THEN
            V_DESC := V_DESC || 'CdRespInspec= ' || NVL(:NEW.CDRESPINSPEC,'') || ' ';
         END IF;

         IF :NEW.CDOPERADOR IS NOT NULL THEN
            V_DESC := V_DESC || 'CdOperador= ' || NVL(:NEW.CDOPERADOR,'') || ' ';
         END IF;

         IF :NEW.VRRESPINSAUD IS NOT NULL THEN
            V_DESC := V_DESC || 'VrRespInsAud= ' || NVL(:NEW.VRRESPINSAUD,'') || ' ';
         END IF;

         IF :NEW.DTRESPINSAUD IS NOT NULL THEN
            V_DESC := V_DESC || 'DtRespInsAud= ' || NVL(TO_CHAR(:NEW.DTRESPINSAUD, 'DD/MM/YYYY'),'') || ' ';
         END IF;

         IF :NEW.DTINITINSAUD IS NOT NULL THEN
            V_DESC := V_DESC || 'DtInitInsAud= ' || NVL(TO_CHAR(:NEW.DTINITINSAUD, 'DD/MM/YYYY'),'') || ' ';
         END IF;

         IF :NEW.DTFIITINSAUD IS NOT NULL THEN
            V_DESC := V_DESC || 'DtFiItInsAud= ' || NVL(TO_CHAR(:NEW.DTFIITINSAUD, 'DD/MM/YYYY'),'') || ' ';
         END IF;

         IF :NEW.DTULTATUITIS IS NOT NULL THEN
            V_DESC := V_DESC || 'DtUltAtuItis= ' || NVL(TO_CHAR(:NEW.DTULTATUITIS, 'DD/MM/YYYY'),'') || ' ';
         END IF;

         IF :NEW.TXRESPINSAUD IS NOT NULL THEN
            V_DESC := V_DESC || 'TxRespInsAud= ' || TO_CHAR(:NEW.TXRESPINSAUD) || ' ';
         END IF;

         IF :NEW.VRPONTINSAUD IS NOT NULL THEN
            V_DESC := V_DESC || 'VrPontInsAud= ' || NVL(:NEW.VRPONTINSAUD,'') || ' ';
         END IF;

         IF :NEW.IDATEINSAUD IS NOT NULL THEN
            V_DESC := V_DESC || 'IdAteInsAud= ' || :NEW.IDATEINSAUD || ' ';
         END IF;

         IF :NEW.IDOPCACEITIN IS NOT NULL THEN
            V_DESC := V_DESC || 'IdOpCaceitin=  ' || :NEW.IDOPCACEITIN || ' ';
         END IF;

         IF :NEW.SGUNIDADE IS NOT NULL THEN
            V_DESC := V_DESC || 'SgUnidade= ' || :NEW.SGUNIDADE || ' ';
         END IF;

         IF :NEW.DSOBSINSAUDI IS NOT NULL THEN
            V_DESC := V_DESC || 'DsObsInsAudi= ' || :NEW.DSOBSINSAUDI || ' ';
         END IF;

         IF :NEW.DSLIMIINSP IS NOT NULL THEN
            V_DESC := V_DESC || 'DsLimiInsp= ' || :NEW.SGUNIDADE || ' ';
         END IF;

         IF :NEW.IDPARCIAL IS NOT NULL THEN
            V_DESC := V_DESC || 'IdParcial= ' || :NEW.IDPARCIAL || ' ';
         END IF;

         IF :NEW.DSANALISE IS NOT NULL THEN
            V_DESC := V_DESC || 'DsAnalise= ' || :NEW.DSANALISE || ' ';
         END IF;

         IF :NEW.SGUNRESPOSTA IS NOT NULL THEN
            V_DESC := V_DESC || 'SgUnResposta= ' || :NEW.SGUNRESPOSTA || ' ' ;
         END IF;

         IF :NEW.IDRESULTIMENS IS NOT NULL THEN
            V_DESC := V_DESC || 'IdResultImens= ' || :NEW.IDRESULTIMENS || ' ' ;
         END IF;

         IF :NEW.CDORDEM IS NOT NULL THEN
            V_DESC := V_DESC || 'CdOrdem= ' || :NEW.CDORDEM || ' ' ;
         END IF;

         IF :NEW.CDREFERENCIA IS NOT NULL THEN
            V_DESC := V_DESC || 'CdReferencia= ' || :NEW.CDREFERENCIA || ' ' ;
         END IF;

         IF :NEW.CDVERSAO IS NOT NULL THEN
            V_DESC := V_DESC || 'CdVersao= ' || :NEW.CDVERSAO || ' ' ;
         END IF;

      V_ITPESQ := :NEW.CDFILIAL || :NEW.NRAUDITORIA || :NEW.NRINSPECAUDI || :NEW.CDINSPECAO || :NEW.CDRESPINSPEC;

      V_IDTIPOOPER := '1';
      V_CDFILLOGOPER := :NEW.CDFILIAL;

   END IF;

      IF UPDATING THEN

         IF (:NEW.CDFILIAL <> :OLD.CDFILIAL) THEN
            V_DESC := V_DESC || 'Filial= ' || NVL(:NEW.CDFILIAL,'') || ' ' ;
         END IF;

         IF (:NEW.NRAUDITORIA <> :OLD.NRAUDITORIA) THEN
            V_DESC := V_DESC || 'NrAudit.= ' || NVL(:NEW.NRAUDITORIA,'') || ' ' ;
         END IF;

         IF (:NEW.NRINSPECAUDI <> :OLD.NRINSPECAUDI) THEN
            V_DESC := V_DESC || 'NrInspecAudit= ' || NVL(:NEW.NRINSPECAUDI,'') || ' ';
         END IF;

         IF (:NEW.CDINSPECAO <> :OLD.CDINSPECAO) THEN
            V_DESC := V_DESC || 'CdInspecao= ' || NVL(:NEW.CDINSPECAO,'') || ' ';
         END IF;

         IF (:NEW.CDRESPINSPEC <> :OLD.CDRESPINSPEC) THEN
            V_DESC := V_DESC || 'CdRespInspec= ' || NVL(:NEW.CDRESPINSPEC,'') || ' ';
         END IF;

         IF (:NEW.CDOPERADOR <> :OLD.CDOPERADOR) THEN
            V_DESC := V_DESC || 'CdOperador= ' || NVL(:NEW.CDOPERADOR,'') || ' ';
         END IF;

         IF (:NEW.VRRESPINSAUD <> :OLD.VRRESPINSAUD) THEN
            V_DESC := V_DESC || 'VrRespInsAud= ' || NVL(:NEW.VRRESPINSAUD,'') || ' ';
         END IF;

         IF (:NEW.DTRESPINSAUD <> :OLD.DTRESPINSAUD) THEN
            V_DESC := V_DESC || 'DtRespInsAud= ' || NVL(TO_CHAR(:NEW.DTRESPINSAUD, 'DD/MM/YYYY'),'') || ' ';
         END IF;

         IF (:NEW.DTINITINSAUD <> :OLD.DTINITINSAUD) THEN
            V_DESC := V_DESC || 'DtInitInsAud= ' || NVL(TO_CHAR(:NEW.DTINITINSAUD, 'DD/MM/YYYY'),'') || ' ';
         END IF;

         IF (:NEW.DTFIITINSAUD <> :OLD.DTFIITINSAUD) THEN
            V_DESC := V_DESC || 'DtFiItInsAud= ' || NVL(TO_CHAR(:NEW.DTFIITINSAUD, 'DD/MM/YYYY'),'') || ' ';
         END IF;

         IF (:NEW.DTULTATUITIS <> :OLD.DTULTATUITIS) THEN
            V_DESC := V_DESC || 'DtUltAtuItis= ' || NVL(TO_CHAR(:NEW.DTULTATUITIS, 'DD/MM/YYYY'),'') || ' ';
         END IF;

         IF (:NEW.TXRESPINSAUD <> :OLD.TXRESPINSAUD) THEN
            V_DESC := V_DESC || 'TxRespInsAud= ' || TO_CHAR(:NEW.TXRESPINSAUD) || ' ';
         END IF;

         IF (:NEW.VRPONTINSAUD <> :OLD.VRPONTINSAUD) THEN
            V_DESC := V_DESC || 'VrPontInsAud= ' || NVL(:NEW.VRPONTINSAUD,'') || ' ';
         END IF;

         IF (:NEW.IDATEINSAUD <> :OLD.IDATEINSAUD) THEN
            V_DESC := V_DESC || 'IdAteInsAud= ' || :NEW.IDATEINSAUD || ' ';
         END IF;

         IF (:NEW.IDOPCACEITIN <> :OLD.IDOPCACEITIN) THEN
            V_DESC := V_DESC || 'IdOpCaceitin=  ' || :NEW.IDOPCACEITIN || ' ';
         END IF;

         IF (:NEW.SGUNIDADE <> :OLD.SGUNIDADE) THEN
            V_DESC := V_DESC || 'SgUnidade= ' || :NEW.SGUNIDADE || ' ';
         END IF;

         IF (:NEW.DSOBSINSAUDI <> :OLD.DSOBSINSAUDI) THEN
            V_DESC := V_DESC || 'DsObsInsAudi= ' || :NEW.DSOBSINSAUDI || ' ';
         END IF;

         IF (:NEW.DSLIMIINSP <> :OLD.DSLIMIINSP) THEN
            V_DESC := V_DESC || 'DsLimiInsp= ' || :NEW.DSLIMIINSP || ' ';
         END IF;

         IF (:NEW.IDPARCIAL <> :OLD.IDPARCIAL) THEN
            V_DESC := V_DESC || 'IdParcial= ' || :NEW.IDPARCIAL || ' ';
         END IF;

         IF (:NEW.DSANALISE <> :OLD.DSANALISE) THEN
            V_DESC := V_DESC || 'DsAnalise= ' || :NEW.DSANALISE || ' ';
         END IF;

         IF (:NEW.SGUNRESPOSTA <> :OLD.SGUNRESPOSTA) THEN
            V_DESC := V_DESC || 'SgUnResposta= ' || :NEW.SGUNRESPOSTA || ' ' ;
         END IF;

         IF (:NEW.IDRESULTIMENS <> :OLD.IDRESULTIMENS) THEN
            V_DESC := V_DESC || 'IdResultImens= ' || :NEW.IDRESULTIMENS || ' ' ;
         END IF;

         IF (:NEW.CDORDEM <> :OLD.CDORDEM) THEN
            V_DESC := V_DESC || 'CdOrdem= ' || :NEW.CDORDEM || ' ' ;
         END IF;

         IF (:NEW.CDREFERENCIA <> :OLD.CDREFERENCIA) THEN
            V_DESC := V_DESC || 'CdReferencia= ' || :NEW.CDREFERENCIA || ' ' ;
         END IF;

         IF (:NEW.CDVERSAO <> :OLD.CDVERSAO) THEN
            V_DESC := V_DESC || 'CdVersao= ' || :NEW.CDVERSAO || ' ' ;
         END IF;

         V_ITPESQ := :NEW.CDFILIAL || :NEW.NRAUDITORIA || :NEW.NRINSPECAUDI || :NEW.CDINSPECAO || :NEW.CDRESPINSPEC;

          V_IDTIPOOPER := '2';
          V_CDFILLOGOPER := :NEW.CDFILIAL;

      END IF;

   IF DELETING  THEN

         IF :OLD.CDFILIAL IS NOT NULL THEN
            V_DESC := V_DESC || 'Filial= ' || NVL(:OLD.CDFILIAL,'') || ' ' ;
         END IF;

         IF :OLD.NRAUDITORIA IS NOT NULL THEN
            V_DESC := V_DESC || 'NrAudit.= ' || NVL(:OLD.NRAUDITORIA,'') || ' ' ;
         END IF;

         IF :OLD.NRINSPECAUDI IS NOT NULL THEN
            V_DESC := V_DESC || 'NrInspecAudit= ' || NVL(:OLD.NRINSPECAUDI,'') || ' ';
         END IF;

         IF :OLD.CDINSPECAO IS NOT NULL THEN
            V_DESC := V_DESC || 'CdInspecao= ' || NVL(:OLD.CDINSPECAO,'') || ' ';
         END IF;

         IF :OLD.CDRESPINSPEC IS NOT NULL THEN
            V_DESC := V_DESC || 'CdRespInspec= ' || NVL(:OLD.CDRESPINSPEC,'') || ' ';
         END IF;

         IF :OLD.CDOPERADOR IS NOT NULL THEN
            V_DESC := V_DESC || 'CdOperador= ' || NVL(:OLD.CDOPERADOR,'') || ' ';
         END IF;

         IF :OLD.VRRESPINSAUD IS NOT NULL THEN
            V_DESC := V_DESC || 'VrRespInsAud= ' || NVL(:OLD.VRRESPINSAUD,'') || ' ';
         END IF;

         IF :OLD.DTRESPINSAUD IS NOT NULL THEN
            V_DESC := V_DESC || 'DtRespInsAud= ' || NVL(TO_CHAR(:OLD.DTRESPINSAUD, 'DD/MM/YYYY'),'') || ' ';
         END IF;

         IF :OLD.DTINITINSAUD IS NOT NULL THEN
            V_DESC := V_DESC || 'DtInitInsAud= ' || NVL(TO_CHAR(:OLD.DTINITINSAUD, 'DD/MM/YYYY'),'') || ' ';
         END IF;

         IF :OLD.DTFIITINSAUD IS NOT NULL THEN
            V_DESC := V_DESC || 'DtFiItInsAud= ' || NVL(TO_CHAR(:OLD.DTFIITINSAUD, 'DD/MM/YYYY'),'') || ' ';
         END IF;

         IF :OLD.DTULTATUITIS IS NOT NULL THEN
            V_DESC := V_DESC || 'DtUltAtuItis= ' || NVL(TO_CHAR(:OLD.DTULTATUITIS, 'DD/MM/YYYY'),'') || ' ';
         END IF;

         IF :OLD.TXRESPINSAUD IS NOT NULL THEN
            V_DESC := V_DESC || 'TxRespInsAud= ' || TO_CHAR(:OLD.TXRESPINSAUD) || ' ';
         END IF;

         IF :OLD.VRPONTINSAUD IS NOT NULL THEN
            V_DESC := V_DESC || 'VrPontInsAud= ' || NVL(:OLD.VRPONTINSAUD,'') || ' ';
         END IF;

         IF :OLD.IDATEINSAUD IS NOT NULL THEN
            V_DESC := V_DESC || 'IdAteInsAud= ' || :OLD.IDATEINSAUD || ' ';
         END IF;

         IF :OLD.IDOPCACEITIN IS NOT NULL THEN
            V_DESC := V_DESC || 'IdOpCaceitin=  ' || :OLD.IDOPCACEITIN || ' ';
         END IF;

         IF :OLD.SGUNIDADE IS NOT NULL THEN
            V_DESC := V_DESC || 'SgUnidade= ' || :OLD.SGUNIDADE || ' ';
         END IF;

         IF :OLD.DSOBSINSAUDI IS NOT NULL THEN
            V_DESC := V_DESC || 'DsObsInsAudi= ' || :OLD.DSOBSINSAUDI || ' ';
         END IF;

         IF :OLD.DSLIMIINSP IS NOT NULL THEN
            V_DESC := V_DESC || 'DsLimiInsp= ' || :OLD.DSLIMIINSP || ' ';
         END IF;

         IF :OLD.IDPARCIAL IS NOT NULL THEN
            V_DESC := V_DESC || 'IdParcial= ' || :OLD.IDPARCIAL || ' ';
         END IF;

         IF :OLD.DSANALISE IS NOT NULL THEN
            V_DESC := V_DESC || 'DsAnalise= ' || :OLD.DSANALISE || ' ';
         END IF;

         IF :OLD.SGUNRESPOSTA IS NOT NULL THEN
            V_DESC := V_DESC || 'SgUnResposta= ' || :OLD.SGUNRESPOSTA || ' ' ;
         END IF;

         IF :OLD.IDRESULTIMENS IS NOT NULL THEN
            V_DESC := V_DESC || 'IdResultImens= ' || :OLD.IDRESULTIMENS || ' ' ;
         END IF;

         IF :OLD.CDORDEM IS NOT NULL THEN
            V_DESC := V_DESC || 'CdOrdem= ' || :OLD.CDORDEM || ' ' ;
         END IF;

         IF :OLD.CDREFERENCIA IS NOT NULL THEN
            V_DESC := V_DESC || 'CdReferencia= ' || :OLD.CDREFERENCIA || ' ' ;
         END IF;

         IF :OLD.CDVERSAO IS NOT NULL THEN
            V_DESC := V_DESC || 'CdVersao= ' || :OLD.CDVERSAO || ' ' ;
         END IF;

      V_ITPESQ := :OLD.CDFILIAL || :OLD.NRAUDITORIA || :OLD.NRINSPECAUDI || :OLD.CDINSPECAO || :OLD.CDRESPINSPEC;

      V_IDTIPOOPER := '3';
      V_CDFILLOGOPER := :OLD.CDFILIAL;

   END IF;

   IF NOT (V_DESC IS NULL) THEN

      V_LENGTH := LENGTH(V_DESC);

      WHILE V_LENGTH >= V_CONT_LENGTH LOOP

         V_GRAV_DESC := SUBSTR(V_DESC, V_CONT_LENGTH, 300);
         V_CONT_LENGTH := V_CONT_LENGTH + 300;

         INSERT INTO LOGOPERA ( NMTABELA, DTOPERACAO, NMRESPOPER,
                                IDTIPOOPER,   DSOPERACAO, CDPESQITEM,
                                DSRDMUSUOPER, DSENDUSUOPER, DSNMUSUOPER,
                                DSMETUSUOPER, CDORESPOPER, CDFILLOGOPER)
                      VALUES  ('ITEMINSAUDIT', SYSDATE ,    NVL(V_NMOPERADOR,' '),
                                V_IDTIPOOPER,   V_GRAV_DESC, V_ITPESQ,
                                V_DSSERVERRDM, V_DSREMOTEADDR,  V_DSREMOTEHOST,
                                V_DSSERVMETHOD,   V_DSREMOTEOPER, V_CDFILLOGOPER); 
  
      END LOOP;       
   END IF;
END;

/
-- VERSAO --
BEGIN ATUVEROBJ('LOG_QPR_ITEMINSAUDIT','6.19.xxx'); END;
/
